/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'cpu.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.cpu.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.cpu.mode.*;

import static ru.ispras.microtesk.model.cpu.shared.Shared.*;

public final class ADD extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         ADD.class,
         "ADD",
         false,
         new ArgumentDecls(),
         false,
         false,
         false,
         false,
         false,
         0,
         new Shortcuts()
             .addShortcut(new Info_alu_instr(), "#root")
      );
    }

    @Override
    public IOperation create(Map<String, Object> args) {
      return new ADD();
    }
  }

  private static final class Info_alu_instr extends InfoAndRule {
    Info_alu_instr() {
      super(
          alu_instr.class,
          "ADD",
          true,
          new ArgumentDecls()
              .add("op1", ArgumentMode.INOUT, OPRNDL.INFO)
              .add("op2", ArgumentMode.IN, OPRNDR.INFO),
          false,
          false,
          false,
          false,
          false,
          0
      );
    }

    @Override
    public IOperation create(Map<String, Object> args) {
      final IAddressingMode op1 = (IAddressingMode) getArgument("op1", args);
      final IAddressingMode op2 = (IAddressingMode) getArgument("op2", args);

      return new alu_instr(
        new ADD(),
        op1,
        op2
      );
    }
  }

  public static final IInfo INFO = new Info();

  public ADD() {
  }

  @Override
  public String syntax() {
    return "add";
  }

  @Override
  public String image() {
    return "00";
  }

  @Override
  public void action() {
    try {
    actionBegin();
    DEST.access().store(SRC1.access().load().add(SRC2.access().load()));
    Execution.trace("%d + %d = %d", SRC1.access().load().bigIntegerValue(), SRC2.access().load().bigIntegerValue(), DEST.access().load().bigIntegerValue());
    } finally {
    actionEnd();
    }
  }
}
