/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'vliw.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.vliw.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.vliw.shared.Shared.*;

public final class C_LT_S extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         C_LT_S.class,
         "C_LT_S",
         false,
         new ArgumentDecls()
             .add("ft", ArgumentMode.IN, F.INFO)
             .add("fs", ArgumentMode.IN, F.INFO)
             .add("cc", COND_CODE),
         false,
         false,
         false,
         false,
         false,
         0);
    }

    @Override
    public IOperation create(Map<String, Object> args) {
      final F ft = (F) getArgument("ft", args);
      final F fs = (F) getArgument("fs", args);
      final Location cc = (Location) getArgument("cc", args);

      return new C_LT_S(ft, fs, cc);
    }
  }

  public static final IInfo INFO = new Info();

  private final F ft;
  private final F fs;
  private final Location cc;

  public C_LT_S(F ft, F fs, Location cc) {
    assert F.INFO.isSupported(ft);
    assert F.INFO.isSupported(fs);
    assert COND_CODE.equals(cc.getType());

    this.ft = ft;
    this.fs = fs;
    this.cc = cc;
  }

  @Override
  public String syntax() {
    return String.format("C_LT_S %d, %s, %s", cc.load().bigIntegerValue(), fs.syntax(), ft.syntax());
  }

  @Override
  public String image() {
    return String.format("01000110000%s%s%s00111100", ft.image(), fs.image(), cc.load().toString());
  }

  @Override
  public void action() {
    try {
    actionBegin();
    if ((fs.access().load().compareTo(ft.access().load()) < 0)) {
      FCCR.access().bitField(cc.load(), cc.load()).store(Data.valueOf(Type.INT(1), 0x1));
    } else {
      FCCR.access().bitField(cc.load(), cc.load()).store(Data.valueOf(Type.INT(1), 0x0));
    }
    } finally {
    actionEnd();
    }
  }
}
